{{- if and (.Values.externalSecrets) (.Values.externalSecrets.enable) -}}
apiVersion: argoproj.io/v1alpha1
kind: Application
metadata:
  name: external-secrets
  namespace: {{ .Values.argoNamespace | default "argocd" }}
  finalizers:
  - resources-finalizer.argocd.argoproj.io
  annotations:
    argocd.argoproj.io/sync-wave: "2"
spec:
  project: {{ .Values.argoProject | default "default" }}
  source:
    repoURL: {{ .Values.repoUrl }}
    path: add-ons/external-secrets
    targetRevision: {{ .Values.targetRevision }}
    helm:
      values: |
        external-secrets:
        {{- toYaml .Values.externalSecrets | nindent 10 }}
      parameters:
      - name: "aws.accountId"
        value: "{{ .Values.account }}"
      - name: "aws.region"
        value: {{ .Values.region }}
      - name: "aws.roleArn"
        value: {{ .Values.externalSecrets.roleArn }}
  destination:
    server: {{ .Values.destinationServer | default "https://kubernetes.default.svc" }}
    namespace: kube-system
  syncPolicy:
    automated:
      prune: true
    syncOptions:
      - CreateNamespace={{ .Values.externalSecrets.createNamespace }}
      - ServerSideApply=true
    retry:
      limit: 1
      backoff:
        duration: 5s
        factor: 2
        maxDuration: 1m
{{- end -}}
